import { routerRedux } from 'dva/router';
import { fetchDomains, switchDomain, currentDomain } from '../services/domain';
import { setCookie, setLocalStorge, fullPath } from '../utils/helper';
import { cookie, storage } from '../utils/config';

export default {

  namespace: 'domain',

  state: {
    list: [],
  },

  subscriptions: {
    setup({ dispatch }) {  // eslint-disable-line
    },
  },

  effects: {
    *fetch(action, { put, call }) {
      const list = yield call(fetchDomains);
      yield put({ type: 'querySuccess', payload: list });
    },
    *switch({ payload: domainId }, { put, call }) {
      yield call(switchDomain, domainId);
      const { id, name } = yield call(currentDomain);
      setCookie(cookie.domain, id);
      setLocalStorge(storage.domainName, name);
      yield put(routerRedux.push(fullPath('/main')));
    },
  },

  reducers: {
    querySuccess(state, { payload: list }) {
      return {
        ...state,
        list,
      };
    },
  },

};
