import { routerRedux } from 'dva/router';
import { login } from '../services/login';
import { setCookie, setLocalStorge, fullPath } from '../utils/helper';
import { cookie, storage } from '../utils/config';

export default {
  namespace: 'login',
  state: {},
  reducers: {},
  effects: {
    *login({ payload }, { call, put }) {
      const result = yield call(login, payload);
      const { tokenId, userId, userName } = result;
      setCookie(cookie.token, tokenId);
      setCookie(cookie.user, userId);
      setLocalStorge(storage.userName, userName);
      yield put(routerRedux.push(fullPath('/domain')));
    },
  },
  subscriptions: {},
};
