import { mapKeys, toPairs, isUndefined } from 'lodash';
import request, { normParams } from '../utils/request';
import { split } from '../utils/filter';
import { is } from '../utils/helper';

const parseFilters = filtersIn => (filtersIn || []).map(({ key, filter }) => [
  `f-${split(key).map(value => value.replace(/#/g, '##').replace(/|/g, '#|')).join('|')}`,
  filter,
]);

// const parseCoordinate = (coordinate) => {
//   if (is(coordinate, 'String')) {
//     return {
//       query:
//     }
//   }
// }

export async function calcDatasource(coordinate, { pst, psz, filters = [], params = {} }) {
  const queryParams = [
    ...toPairs({ pst, psz }),
    ...parseFilters(filters),
    ...normParams(mapKeys(params, (v, k) => `p-${k}`)),
  ].filter(isUndefined);
  return request(`/api/datasource/${name}`, queryParams);
}

export async function countDatasource(name, { filters = [], params = {} }) {
  const queryParams = [
    ...parseFilters(filters),
    ...normParams(mapKeys(params, (v, k) => `p-${k}`)),
  ].filter(isUndefined);
  return request(`/api/datasource/${name}/count`, queryParams);
}

export async function getDatasourceMeta(name) {
  return request(`/api/datasource/${name}`);
}

