import React from 'react';

import { storiesOf } from '@storybook/react';

import dva from 'dva';
import createLoading from 'dva-loading';
import DsTable from '../src/components/table/dstable';

import { login } from '../src/services/login';
import { switchDomain } from '../src/services/domain';
import { allModuleInfos, getModuleConfigure } from '../src/services/modules';
import { setCookie, setLocalStorge } from '../src/utils/helper';
import { cookie, storage } from '../src/utils/config';

const loginIt = async (userName, password, domainId) => {
  const result = await login({ userName, password });
  const { tokenId, userId } = result;
  setCookie(cookie.token, tokenId);
  setCookie(cookie.user, userId);
  setLocalStorge(storage.userName, userName);
  await switchDomain(domainId);
  const moduleInfos = await allModuleInfos();
  console.log(moduleInfos);
  if (moduleInfos.length > 0) {
    const module = await getModuleConfigure(moduleInfos[0].name);
    console.log(module);
  }
};

loginIt('cxj', '111111', 5).catch(err => console.log(err));



const Wrapper = () => Comp => (props) => {
  const app = dva({});
  app.use(createLoading({
    effects: true,
  }));
  const { children, ...rest } = props;
  app.router(() => <Comp app={app} {...rest}>{ children }</Comp>);
  return app.start()();
};

storiesOf('a', module)
  .add('1', () => {
    const Comp = Wrapper()(DsTable);
    return <Comp />;
  });
